#!/root/hb/bin/python
#import pydevd;pydevd.settrace('192.168.5.25',port=5678)

import csv
import serial
import time
import numpy as np

class SerialUSB:
    def __init__(self, t):
        if t == 0 : t =0.1
        try:
            self.connect = serial.Serial('/dev/ttyUSB0',115200,timeout=t)
#        ser = serial.Serial('/dev/ttyUSB0')
            print('Open USB serial conection:')
            print('\t',self.connect)
        except:
            print('USB error: Perhaps the controller or operator is unplugged.')
    
    def Write(self,s):
        self.connect.write(s)
        
    def ReadLines(self):
        return(self.connect.readlines())
    
    def ReadLine(self):
        return(self.connect.readline())
    
    def Read(self,bytes):
        return(self.connect.read(bytes))

class GTT50A:
    
    ellip_size = [5,5]
    
    def __init__(self,state,gttUSB,azimuth_data,elevation_data,microphone_collection):
        self.state = "0"
        self.gttUSB = SerialUSB(0)
        self.azimuth_data = []
        self.elevation_data = []
        self.microphone_collection = []
   
    def setData(self,azimuth_data,elevation_data):
        self.azimuth_data = azimuth_data
        self.elevation_data = elevation_data
    
    def setXY(self,X,Y):
        self.X = X 
        self.Y = Y
        
    def setDotColor(self, c):
        self.color = c
        
    def runRoutine(self,initial_state):
        print(self.gttUSB)
        #gttUSB.Write([254,1])
        #time.sleep(10)
        
        set_drawing_color = [254,99]
        #microphone_collection = []
        configuration_flag = False 
        #gttUSB.Write(clearscreen)
        
        
        #my_var = gttUSB.Write([254,100])
        #for i in range(0,20):
        
        # Image Center 505 242
    
        #drawEllipse([505,242],[3,3],gttUSB)
        current_state = initial_state
        time.sleep(0.200)
        my_state = self.readUserInput()
        if(current_state != my_state and my_state!= None):
            print('curent state: ' + current_state + ' my_state: ' + my_state)
            if(my_state == "11"):
                self.plottingSequence(set_drawing_color)
                # use data stream if plotting from a file
                #self.dataStreamPlotting(set_drawing_color)
            if(my_state == "13"):
                self.writeLog()
            if(my_state == "15"):
                print(self.microphone_collection)    
                configuration_flag = True
                self.recolorButtons()
                    
            if(len(np.unique(self.microphone_collection)) < 8):
                if(my_state == "1"):
                    self.microphone_collection.append(1)
                if(my_state == "2"):
                    self.microphone_collection.append(2)
                if(my_state == "3"):
                    self.microphone_collection.append(3)
                if(my_state == "4"):
                    self.microphone_collection.append(4)
                if(my_state == "5"):
                    self.microphone_collection.append(5)
                if(my_state == "6"):
                    self.microphone_collection.append(6)
                if(my_state == "7"):
                    self.microphone_collection.append(7)
                if(my_state == "8"):
                    self.microphone_collection.append(8) 
                if(my_state == "9"):
                    self.microphone_collection.append(9) 
                if(my_state == "10"):
                    self.microphone_collection.append(10)
                        #recolorButtons(gttUSB)
            if(my_state == "12"):
                self.microphone_collection = []
            if(my_state == "0"):
                if(configuration_flag):
                    print(self.microphone_collection)
                configuration_flag = False
            if(my_state == "14"):
                time.sleep(0.20)
                    #plottingSequence(gttUSB)
            return [current_state,my_state]
            current_state = my_state
    
    def drawEllipse(self,coor,ell_size):
        
        # initiate drawing
        time.sleep(0.005)
        self.gttUSB.Write([254,126])
        # parse ellipse parameters
        my_var_1 = (coor[0]).to_bytes(2, byteorder="big", signed=True)
        my_var_2 =  (coor[1]).to_bytes(2, byteorder="big", signed=True)
        my_var_3 = (ell_size[0]).to_bytes(2, byteorder="big", signed=False)
        my_var_4 = (ell_size[1]).to_bytes(2, byteorder="big", signed=False)
        
        self.gttUSB.Write(my_var_1)
        self.gttUSB.Write(my_var_2)
        self.gttUSB.Write(my_var_3)
        self.gttUSB.Write(my_var_4)
    
    def drawEmptyEllipse(self,coor,ell_size):
        
        # initiate drawing
        time.sleep(0.005)
        self.gttUSB.Write([254,125])
        # parse ellipse parameters
        my_var_1 = (coor[0]).to_bytes(2, byteorder="big", signed=True)
        my_var_2 =  (coor[1]).to_bytes(2, byteorder="big", signed=True)
        my_var_3 = (ell_size[0]).to_bytes(2, byteorder="big", signed=False)
        my_var_4 = (ell_size[1]).to_bytes(2, byteorder="big", signed=False)
        
        self.gttUSB.Write(my_var_1)
        self.gttUSB.Write(my_var_2)
        self.gttUSB.Write(my_var_3)
        self.gttUSB.Write(my_var_4)
    
    
    # switches color to black for display
    def colorBlack(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\x00\x00\x00')
        
    # switches color to white for display 
    def colorWhite(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\xff\xff\xff')
    
    def colorGray(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\xcc\xcc\xcc')
    
    def colorRed(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\xff\x00\x00')    
    
    def colorRedText(self):
        set_drawing_color = [254,46]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\xff\x00\x00')
    
    def colorBlue(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\x00\x00\xff')
    
    def colorGreen(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\x00\xff\x00')
    
    def colorLightGreen(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\x44\xff\x44')
    
    def colorLightBlue(self):
        set_drawing_color = [254,99]
        self.gttUSB.Write(set_drawing_color)
        self.gttUSB.Write(b'\x44\x44\xff')
    
    # reads file data and plots locations to screen
    def readFile(self):
        # initialize arrays
        azimuth_data = []
        elevation_data = []
        iterator = 0
        r = 1
        # read file in CSV format
        with open('point_data.txt', newline='') as csvfile:
            spamreader = csv.reader(csvfile, delimiter=' ')
            for row in spamreader:
                for element in row:
                    if(len(element.strip())!= 0):
                        iterator = iterator +1 
                        if( (iterator-18) >= 0 and ((iterator-18) % 10 ==0)):
                            azimuth_data.append(element)
                        if( (iterator-19) >= 0 and ((iterator-19) % 10 ==0)):
                            elevation_data.append(element)
        
        # draw ellipses to screen
        for ii in range(0,len(azimuth_data)):
            #time.sleep(0.100)
            y = r*np.sin(float(elevation_data[ii])*np.pi/180)
            x = r*np.cos(float(elevation_data[ii])*np.pi/180)*np.cos(float(azimuth_data[ii])*np.pi/180)
            self.drawEllipse([504+int(float(x)*5500/30),241-int(float(y)*5560/30)],self.ellip_size)
    # draws circles using a data stream of azimuth and elevation values
    def dataStreamDraw(self):
        r = 1
        azimuth_data = self.azimuth_data
        elevation_data = self.elevation_data
        for ii in range(0,len(azimuth_data)):
            #time.sleep(0.100)
            y = r*np.sin(float(elevation_data[ii])*np.pi/180)
            x = r*np.cos(float(elevation_data[ii])*np.pi/180)*np.cos(float(azimuth_data[ii])*np.pi/180)
            self.drawEllipse([504+int(float(x)*5500/30),241-int(float(y)*5560/30)],self.ellip_size)
    
    def dataStreamCartesian(self):
        
        for ii in range(0,len(self.X)):
            #time.sleep(0.100)
            x = self.X[ii]
            y = self.Y[ii]
            self.drawEllipse([504+int(float(x)*5500/30),241-int(float(y)*5560/30)],self.ellip_size)
    
    def dataStreamCartesianColor(self):

        for ii in range(0,len(self.X)):

            if self.color[ii] == 'blue':
                self.colorBlue()
            elif self.color[ii] == 'light blue':
                self.colorLightBlue()
            elif self.color[ii] == 'green':
                self.colorGreen()
            elif self.color[ii] == 'light green':
                self.colorLightGreen()
            
            #time.sleep(0.100)
            x = self.X[ii]
            y = self.Y[ii]
            self.drawEllipse([504+int(float(x)*5500/30),241-int(float(y)*5560/30)],self.ellip_size)
        
    
    def dataStreamCartesianC(self, xlist, ylist, color):
        
        for x, y, c in zip(xlist, ylist, color):
            
            if c == 'blue':
                self.colorBlue()
            elif c == 'light blue':
                self.colorLightBlue()
            elif c == 'green':
                self.colorGreen()
            elif c == 'light green':
                self.colorLightGreen()
            
            self.drawEllipse([504+int(float(x)*5500/30), 241-int(float(y)*5560/30)], self.ellip_size)
    
    # draws plots using a data stream requires set data
    def dataStreamPlotting(self,set_drawing_color):
        self.colorBlue()
        #self.colorGreen()
        # call as needed to change color to green condition can be used further downstream 
        self.dataStreamDraw()
        self.colorWhite()
        self.dataStreamDraw()
        self.refreshGrid()
    
    def dataStreamPlot(self, color):
        if color == 'blue':
            self.colorBlue()
            #self.colorGreen()
            # call as needed to change color to green condition can be used further downstream 
            self.dataStreamCartesian()

        elif color == 'light blue':
            self.colorLightBlue()
            #self.colorGreen()
            # call as needed to change color to green condition can be used further downstream 
            self.dataStreamCartesian()

        elif color == 'green':
            self.colorGreen()
            #self.colorGreen()
            # call as needed to change color to green condition can be used further downstream 
            self.dataStreamCartesian()
            
        elif color == 'light green':
            self.colorLightGreen()
            #self.colorGreen()
            # call as needed to change color to green condition can be used further downstream 
            self.dataStreamCartesian()
            
            
    def dataStreamErase(self):
        self.colorWhite()
        self.dataStreamCartesian()
        self.refreshGrid()

    # draws lines primarly used to quickly refresh display
    def drawLine(self,coor):
        # coor array format is X1 Y1 X2 Y2 
        draw_line = [254,108]
        self.gttUSB.Write(draw_line)
        # convert signed shorts to bytes
        my_var_1 = (coor[0]).to_bytes(2, byteorder="big", signed=True)
        my_var_2 =  (coor[1]).to_bytes(2, byteorder="big", signed=True)
        my_var_3 = (coor[2]).to_bytes(2, byteorder="big", signed=True)
        my_var_4 = (coor[3]).to_bytes(2, byteorder="big", signed=True)
        # write byte data to display
        self.gttUSB.Write(my_var_1)
        self.gttUSB.Write(my_var_2)
        self.gttUSB.Write(my_var_3)
        self.gttUSB.Write(my_var_4)
        
    # refreshes the Cartesian Grid
    # Note this can be changed to bitmap but will be more expensive 
    # currently hard coded but should be relatively easy to recreate 
    def refreshGrid(self):
        
        self.colorBlack()
    
        self.drawEmptyEllipse([504,241],[91,91])
        self.drawEmptyEllipse([504,241],[92,92])
        self.drawEmptyEllipse([504,241],[160,160])
        self.drawEmptyEllipse([504,241],[161,161])
        self.drawEmptyEllipse([504,241],[162,162])
        self.drawEmptyEllipse([504,241],[183,183])
        self.drawEmptyEllipse([504,241],[184,184])
        self.drawEmptyEllipse([504,241],[185,185])
    
        self.colorBlue()
        # refresh center lines    
            
        # redraw black vertical lines
        self.drawLine([504,59,504,424])
        self.drawLine([503,59,503,424])
        # redraw blue horizontal lines
        self.drawLine([319,242,688,242])
        self.drawLine([319,243,688,243])
    
        # fix axis line
        #drawLine([270,55,270,432],gttUSB)
        #drawLine([271,55,271,432],gttUSB)
    
    # read user Input from Screen
    
    def readUserFast(self):
        #time.sleep(0.1)
        self.gttUSB.Write([254,53])
        #time.sleep(0.100)
        temp = self.gttUSB.Read(255) 
        if(len(temp) != 0):
            print(str(len(temp)) + ": " + str(temp[len(temp)-1]))
            return str(temp[len(temp)-1])
    
    def readUserInput(self):
        time.sleep(0.05)
        self.gttUSB.Write([254,53])
        time.sleep(0.05)
        temp = self.gttUSB.Read(255) 
        if(len(temp) != 0):
            #print(str(len(temp)) + ": " + str(temp[len(temp)-1]))
            return str(temp[len(temp)-1])
    
    # runs plotting sequence for display
    def plottingSequence(self,set_drawing_color):
        self.gttUSB.Write(set_drawing_color)
        #color_array = bytes([0,0,255])
        self.gttUSB.Write(b'\x00\x00\xff')
        self.readFile()
        self.colorWhite()
        self.readFile()
        self.refreshGrid()
        
    def writeLog(self):
        
        azimuth_data = []
        elevation_data = []
        iterator = 0
        # setFontSize(gttUSB,60)
        # similar to file reader  
        with open('point_data.txt', newline='') as csvfile:
            spamreader = csv.reader(csvfile, delimiter=' ')
            for row in spamreader:
                for element in row:
                    if(len(element.strip())!= 0):
                        iterator = iterator +1 
                        if((iterator-18) >= 0 and ((iterator-18) % 10 ==0)):
                            if(self.readUserInput() != "13"):
                                return
                            self.gttUSB.Write(b'Azimuth: ')
                            self.gttUSB.Write(element.encode('utf-8'))
                            azimuth_data.append(element)
                            time.sleep(0.010)
                        if((iterator-19) >= 0 and ((iterator-19) % 10 ==0)):
                            self.gttUSB.Write(b' Elevation: ')
                            self.gttUSB.Write(element.encode('utf-8'))
                            elevation_data.append(element)
                            self.gttUSB.Write(b'\n')
                        if(iterator % 120 == 0):
                            self.resetLogScreen()      
    
    def streamLog(self):
        self.resetLogScreen()
        for ii in range(0,len(self.azimuth_data)):
            if(self.readUserInput() != '13'):
                return 
            self.gttUSB.Write(b'Azimuth: ')
            self.gttUSB.Write(self.azimuth_data[ii].encode('utf-8'))
            time.sleep(0.010)
            
            self.gttUSB.Write(b' Elevation: ')
            self.gttUSB.Write(self.elevation_data[ii].encode('utf-8'))
            self.gttUSB.Write(b'\n')
            time.sleep(0.010)
            if((ii+1) % 11 == 0):
                self.resetLogScreen() 
        

    def streamLogText(self, t):
        if(self.readUserInput() != '13'):
            return 
        self.resetLogScreen()
        #self.gttUSB.Write(b'Azi    Elev   c_est      LSE')
        for ii in range(0, len(t)):
            if(self.readUserInput() != '13'):
                return 
            self.gttUSB.Write(t[ii].encode('utf-8'))
            if((ii+1) % 11 == 0):
                self.resetLogScreen() 
        
        
    # currently broken will be fixed in next version do not use
    def setFontSize(self,num):
        
        # start loading Font
        self.gttUSB.Write([254,40])
        self.gttUSB.Write(b'\x01')
        self.gttUSB.Write(b'Bluebird.otf')  
        
        num_b = num.to_bytes(1, byteorder="big", signed=False)
        self.gttUSB.Write([254,51])
        time.sleep(0.100)
        self.gttUSB.Write(num_b)
        self.gttUSB.Write([254,61])
        time.sleep(0.100)
        temp = self.gttUSB.Read(255)
        print(temp)
        
    def recolorButtons(self):
        
        #setFontSize(gttUSB,28)
        for mic in self.microphone_collection:
            #time.sleep(0.100)
            #gttUSB.Write(b'This is Hao Vu\n')
            if(mic == 1):
                self.colorBlue()
                self.drawEllipse([380,130],[20,20])
                self.setTextInsertionPoint([370,120])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'1')
            if(mic == 2):
                self.colorBlue()
                self.drawEllipse([540,130],[20,20])
                self.setTextInsertionPoint([530,120])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'2')
            if(mic == 3):
                self.colorBlue()
                self.drawEllipse([265,60],[20,20])
                self.setTextInsertionPoint([255,50])
                #colorRed(gttUSB)
                self.gttUSB.Write(b'3')
            if(mic == 4):
                self.colorBlue()
                self.drawEllipse([660,60],[20,20])
                self.setTextInsertionPoint([650,50])
                #colorRedText(gttUSB)
                #time.sleep(0.100)
                self.gttUSB.Write(b'4')
            if(mic == 5):
                self.colorBlue()
                self.drawEllipse([665,380],[20,20])
                self.setTextInsertionPoint([655,370])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'5')
            if(mic == 6):
                self.colorBlue()
                self.drawEllipse([540,330],[20,20])
                self.setTextInsertionPoint([530,320])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'6')
            if(mic == 7):
                self.colorBlue()
                self.drawEllipse([265,380],[20,20])
                self.setTextInsertionPoint([255,370])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'7')
            if(mic == 8):
                self.colorBlue()
                self.drawEllipse([380,330],[20,20])
                self.setTextInsertionPoint([370,320])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'8')
            if(mic == 9):
                self.colorBlue()
                self.drawEllipse([380,230],[20,20])
                self.setTextInsertionPoint([370,220])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'9')
            if(mic == 10):
                self.colorBlue()
                self.drawEllipse([530,230],[20,20])
                self.setTextInsertionPoint([520,220])
                #colorRedText(gttUSB)
                self.gttUSB.Write(b'10')
            # send label ID
            #gttUSB.Write(label_id)
            # set label color to red
            #gttUSB.Write(b'\xff\x00\x00')
            print('Coloring Buttons \n')
    
    def setTextInsertionPoint(self,coord):
        self.gttUSB.Write([254,121])
        loc_1 = coord[0]
        loc_2 = coord[1]
        
        loc_1_b = loc_1.to_bytes(2, byteorder="big", signed=False)
        loc_2_b = loc_2.to_bytes(2, byteorder="big", signed=False)
        
        self.gttUSB.Write(loc_1_b)
        self.gttUSB.Write(loc_2_b)
    
    def resetLogScreen(self):
        self.gttUSB.Write([254,121])
        loc_1 = 0
        loc_2 = 0
        width = 800
        height= 400
        
        loc_1_b = loc_1.to_bytes(2, byteorder="big", signed=False)
        loc_2_b = loc_2.to_bytes(2, byteorder="big", signed=False)
        width_b = width.to_bytes(2, byteorder="big", signed=False)
        height_b = height.to_bytes(2, byteorder="big", signed=False)
        
        
        self.gttUSB.Write(loc_1_b)
        self.gttUSB.Write(loc_2_b)
        self.colorBlack()
        self.gttUSB.Write([254,120])
        self.gttUSB.Write(loc_1_b)
        self.gttUSB.Write(loc_2_b)
        self.gttUSB.Write(width_b)
        self.gttUSB.Write(height_b)

if __name__ == '__main__':
    
    screen_1 = GTT50A(0,"0",[],[],[])
    while(True):
        # Example call to set azimuth and elevation data arrays
        # screen_1.setData([15,30,60,90],[15,30,60,90])
        # update continously to stream data
        states = screen_1.runRoutine("0")
        #print('curent state: ' + states[0] + ' my_state: ' + states[1])

